import { BaseDevice } from './BaseDevice';
export interface IMP1State {
    socketId: 's1' | 's2' | 's3' | 's4';
    status: 'on' | 'off';
}
export declare class MP1 extends BaseDevice {
    type: string;
    constructor(host: any, mac: any, timeout?: number);
    /**
     * Sets the power state of the smart power strip.
     * @param sid_mask
     * @param state
     */
    setPowerMask(sidMask: any, state: any): void;
    /**
     * Sets the power state of the smart power strip.
     */
    setPower(sid: any, state: any): void;
    setState(state: IMP1State): void;
    /**
     * Returns the power state of the smart power strip in raw format
     */
    requestState(): void;
}
