"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BaseDevice_1 = require("./BaseDevice");
var RM = /** @class */ (function (_super) {
    __extends(RM, _super);
    function RM(host, mac, timeout) {
        if (timeout === void 0) { timeout = 10; }
        var _this = _super.call(this, host, mac, timeout) || this;
        _this.type = 'RM2';
        _this.on('payload', function (err, data) {
            if (err) {
                _this.emit('error', err);
            }
            var payloadType = data[0];
            var state;
            switch (payloadType) {
                case 1:// Temperature
                    state = {
                        mac: _this.mac,
                        host: _this.host,
                        status: {
                            temperature: (data[0x4] * 10 + data[0x5]) / 10.0,
                        },
                    };
                    break;
                case 4:// get from check_data
                    var temp = Buffer.alloc(data.length - 4, 0);
                    data.copy(temp, 0, 4);
                    state = {
                        mac: _this.mac,
                        host: _this.host,
                        status: {
                            data: Array.prototype.slice.call(temp, 0),
                        },
                    };
                    break;
            }
            _this.emit('state', state);
        });
        return _this;
    }
    RM.prototype.checkData = function () {
        var packet = Buffer.alloc(16, 0);
        packet[0] = 4;
        this.sendPacket(0x6a, packet);
    };
    RM.prototype.sendData = function (data) {
        var packet = new Buffer([0x02, 0x00, 0x00, 0x00]);
        packet = Buffer.concat([packet, Buffer.from(data)]);
        this.sendPacket(0x6a, packet);
    };
    RM.prototype.enterLearning = function () {
        var packet = Buffer.alloc(16, 0);
        packet[0] = 3;
        this.sendPacket(0x6a, packet);
    };
    RM.prototype.checkTemperature = function () {
        var packet = Buffer.alloc(16, 0);
        packet[0] = 1;
        this.sendPacket(0x6a, packet);
    };
    RM.prototype.requestState = function () {
        this.checkTemperature();
    };
    return RM;
}(BaseDevice_1.BaseDevice));
exports.RM = RM;
//# sourceMappingURL=RM.js.map